/******************************************************************************\
 *           ___        __                                                    *
 *          /\_ \    __/\ \                                                   *
 *          \//\ \  /\_\ \ \____    ___   _____   _____      __               *
 *            \ \ \ \/\ \ \ '__`\  /'___\/\ '__`\/\ '__`\  /'__`\             *
 *             \_\ \_\ \ \ \ \L\ \/\ \__/\ \ \L\ \ \ \L\ \/\ \L\.\_           *
 *             /\____\\ \_\ \_,__/\ \____\\ \ ,__/\ \ ,__/\ \__/.\_\          *
 *             \/____/ \/_/\/___/  \/____/ \ \ \/  \ \ \/  \/__/\/_/          *
 *                                          \ \_\   \ \_\                     *
 *                                           \/_/    \/_/                     *
 *                                                                            *
 * Copyright (C) 2011 - 2014                                                  *
 * Dominik Charousset <dominik.charousset (at) haw-hamburg.de>                *
 *                                                                            *
 * Distributed under the Boost Software License, Version 1.0. See             *
 * accompanying file LICENSE or copy at http://www.boost.org/LICENSE_1_0.txt  *
\******************************************************************************/

#ifndef TIMEOUT_DEFINITION_HPP
#define TIMEOUT_DEFINITION_HPP

#include <functional>

#include "cppa/duration.hpp"

namespace cppa {

namespace detail {
class behavior_impl;
}

template<typename F>
struct timeout_definition {
    static constexpr bool may_have_timeout = true;
    duration timeout;
    F handler;
    detail::behavior_impl* as_behavior_impl() const;

};

using generic_timeout_definition = timeout_definition<std::function<void()>>;

} // namespace cppa

#endif // TIMEOUT_DEFINITION_HPP
